import greenfoot.*;
import java.awt.Color;
import java.util.List;

public class BaseMarker extends Terrain
{
    public BaseMarker(){
        //Make Image
        GreenfootImage image = new GreenfootImage(50,50);
        image.setColor(Color.BLACK);
        image.fill();
        image.setColor(Color.GREEN);
        image.fillRect(2,2,46,46);
        setImage(image);
        getImage().setTransparency(100);
    }
    public void addedToWorld(World world){
        //Make Base
        List markerCheck = getWorld().getObjects(BaseMarker.class);
        if (markerCheck.size()>1){
            Actor marker = (Actor) markerCheck.get(0);
            int width=getX()-marker.getX();
            if (width<0)width=-width;
            width+=50;
            int height=getY()-marker.getY();
            if (height<0)height=-height;
            height+=50;
            int x=getX();
            if (x>marker.getX()){x-=width/2-25;}else{x+=width/2-25;}
            int y=getY();
            if (y>marker.getY()){y-=height/2-25;}else{y+=height/2-25;}
            getWorld().addObject(new Base(width,height),x,y);
            getWorld().removeObject(this);
        }
    }
    public void act(){
        if (getOneObjectAtOffset(0,0,Base.class)!=null)getWorld().removeObject(this);
    }
}
