import greenfoot.*;
import java.awt.Color;
public class Checkpoint extends Level
{
    boolean currentCheckpoint=false;
    public boolean currentCheckpoint(){return currentCheckpoint;}
    int width=25;
    int height=50;
    public Checkpoint(int w, int h){
        width = w;
        height = h;
    }
    public void paintImage(int width, int height, GreenfootImage tile)
    {
        GreenfootImage image = new GreenfootImage(width,height);
        for (int rows=0; rows<height; rows+=tile.getHeight()){
            for(int offset=0; offset<width; offset+=tile.getWidth()) image.drawImage(tile, offset, rows);
        }
        setImage(image);
    }
    public void addedToWorld(World world){
        GreenfootImage image = new GreenfootImage(25,25);
        if (getWorld() instanceof LevelEditor){
            image.setColor(Color.BLACK);
            image.fill();
            image.setColor(new Color(255,0,255));
            image.fillRect(2,2,21,21);
            image.setTransparency(100);
        }
        paintImage(width,height,image);
        Actor terrain = getOneIntersectingObject(Level.class);
        if (getWorld() instanceof LevelEditor&&terrain!=null){getWorld().removeObject(this);}
    }
}
