import greenfoot.*;
import java.awt.Color;
import java.util.List;

public class CheckpointMarker extends Terrain
{
    public CheckpointMarker(){
        //Make Image
        GreenfootImage image = new GreenfootImage(25,25);
        image.setColor(Color.BLACK);
        image.fill();
        image.setColor(new Color(255,0,255));
        image.fillRect(2,2,21,21);
        setImage(image);
        getImage().setTransparency(100);
    }
    public void addedToWorld(World world){
        //Make Base
        List markerCheck = getWorld().getObjects(CheckpointMarker.class);
        if (markerCheck.size()>1){
            Actor marker = (Actor) markerCheck.get(0);
            int width=getX()-marker.getX();
            if (width<0)width=-width;
            width+=25;
            int height=getY()-marker.getY();
            if (height<0)height=-height;
            height+=25;
            int x=getX();
            if (x>marker.getX()){x-=width/2-12;}else{x+=width/2-12;}
            int y=getY();
            if (y>marker.getY()){y-=height/2-12;}else{y+=height/2-12;}
            getWorld().addObject(new Checkpoint(width,height),x,y);
            getWorld().removeObject(this);
        }
    }
    public void act(){
        if (getOneObjectAtOffset(0,0,Checkpoint.class)!=null)getWorld().removeObject(this);
    }
}
