import greenfoot.*;
import java.awt.Color;
import java.util.List;
import javax.swing.JOptionPane;

public class LevelSettingsEditor extends MouseButtons
{
    public void act() 
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        Color c;
        if (mouse!=null&&mouse.getX()>getX()-getImage().getWidth()/2&&mouse.getX()<getX()+getImage().getWidth()/2&&mouse.getY()>getY()-getImage().getHeight()/2&&mouse.getY()<getY()+getImage().getHeight()/2){
            c=Color.YELLOW;
        }else{
            c=Color.BLACK;
        }
        updateImage(c);
        if (Greenfoot.mouseClicked(this)){
            ((LevelEditor)getWorld()).autoScroll(false);
            String s = "";
            s = JOptionPane.showInputDialog(null,"||Editor Commands||\n-Level Scrolling Boundries-\n!Units Measured in Blocks!\nCommand Format: int left/int right/int up/int down\nCurrent Scrolling Boundries: "+((LevelEditor)getWorld()).getLeftLimit()/50+"/"+((LevelEditor)getWorld()).getRightLimit()/50+"/"+((LevelEditor)getWorld()).getUpLimit()/50+"/"+((LevelEditor)getWorld()).getDownLimit()/50+"\n\n-Scroll to Level Origin-\n Command Format: start\n\n-Open Music Editor-\n!This Command Is Not Yet Implemented!\nCommand Format: changeMusic\n\n-New Level-\n!This will delete the current level!\nCommand format: newLevel");
            if (s==null||s.equals(""))return;
            try{
                if (s.indexOf("/")>-1){
                    int l=Integer.parseInt(s.substring(0,s.indexOf("/")));
                    s=s.substring(s.indexOf("/")+1);
                    int r=Integer.parseInt(s.substring(0,s.indexOf("/")));
                    s=s.substring(s.indexOf("/")+1);
                    int u=Integer.parseInt(s.substring(0,s.indexOf("/")));
                    s=s.substring(s.indexOf("/")+1);
                    int d=Integer.parseInt(s);
                    if (l>=0&&r>=0&&u>=0&&d>=0){((LevelEditor)getWorld()).setScrollingLimits(l*50,r*50,u*50,d*50);}else{JOptionPane.showMessageDialog(null,"Unable To Set Scrolling Boundries to Negative Values");}
                    return;
                }
                if (s.equals("start")){((LevelEditor)getWorld()).scrollToBeginning(); return;}
                //if (s.equals("changeMusic")){return;}
                if (s.equals("newLevel")){spawnDefaultMap(); return;}
            }catch(Exception e){e.printStackTrace();}
            JOptionPane.showMessageDialog(null,"Unable to recognize command!");
        }else{((LevelEditor)getWorld()).autoScroll(true);}
    }
    public void updateImage(Color c){
        setImage(new GreenfootImage("Level Settings",30,c,new Color(0,0,0,0)));
    }
    public void deleteCurrentLevel(){
        List terrain = getWorld().getObjects(Terrain.class);
        for (int t=0; t<terrain.size(); t++){
            Actor object = (Actor) terrain.get(t);
            getWorld().removeObject(object);
        }
        getWorld().repaint();
    }
    public void spawnDefaultMap(){
        ((LevelEditor)getWorld()).scrollToBeginning();
        deleteCurrentLevel();
        for (int i=75; i<getWorld().getWidth()-25; i+=50){
            getWorld().addObject(new Box(),i,getWorld().getHeight()-75);
        }
    }
}