/**
 -In passRequest, type "@yn" to have the option be a yes/no input.
 
 -Leave passRequest blank in order to have no input be nessesary.
 
 -Leave the String w blank in order to have the selection not
  function, and have it serve only to display text on the screen.
*/

import greenfoot.*;
import java.awt.Color;
import javax.swing.JOptionPane;

public class MenuSelection extends MouseButtons
{
    String name;
    String image;
    String password;
    String world;
    String passwordRequest;
    int size;
    Color normal=Color.BLACK;
    Color highlighted=Color.WHITE;
    public MenuSelection(String i,String passRequest,String pass, String w,int s, Color n, Color h){
        name=i;
        password=pass;
        passwordRequest=passRequest;
        world=w;
        size=s;
        normal=n;
        highlighted=h;
    }
    public void addedToWorld(World world){
        image=name;
        updateImage(normal);
    }
    public void act() 
    {
        if (world==null)return;
        MouseInfo mouse = Greenfoot.getMouseInfo();
        Color c;
        if (mouse!=null&&mouse.getX()>getX()-getImage().getWidth()/2&&mouse.getX()<getX()+getImage().getWidth()/2&&mouse.getY()>getY()-getImage().getHeight()/2&&mouse.getY()<getY()+getImage().getHeight()/2){
            c=highlighted;
        }else{
            c=normal;
        }
        updateImage(c);
        if (Greenfoot.mouseClicked(this)){
            String s="";
            boolean confirm=false;
            if (!password.equals("")&&!password.equals("@yn")){
                s = JOptionPane.showInputDialog(null,passwordRequest);
            }else if(password.equals("@yn")){
                confirm=(JOptionPane.showConfirmDialog(null,passwordRequest,"Notice",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION);
            }else if(!passwordRequest.equals("")){JOptionPane.showMessageDialog(null,passwordRequest);}
            try{
                if (s.equals(password)||confirm){
                    World load = null;
                    if (world.equals("MainMenu"))load=new MainMenu();
                    if (world.equals("Credits"))load=new Credits();
                    if (world.equals("LevelEditor"))load=new LevelEditor();
                    if (world.equals("XEngine"))load=new XEngine();
                    if (world.equals("Options"))load=new Options();
                    if (load!=null)Greenfoot.setWorld(load);
                }else if(!s.equals(password)&&!s.equals("")){
                    JOptionPane.showMessageDialog(null,"Cannot recognize input.");
                }
            }catch(NullPointerException e){}
        }
    }
    public void updateImage(Color c){
        setImage(new GreenfootImage(image,size,c,new Color(0,0,0,0)));
    }
}
