import greenfoot.*;
import java.awt.Color;
import javax.swing.JOptionPane;

public class Options extends World
{
    UserInfo info;
    String[] keys = {"","a","b","c","d","e","f","g","h","i","j","k","l",/*"m",*/"n",/*"o","p",*/"q","r","s","t","u","v","w","x","y","z","left","right","up","down","enter","space","tab","escape","backspace","shift","control"};
    String[] binds = {"a","d","w","s","q","e","up","left","right","space"};
    public Options()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1);
        addObject(new Fps(),35,50);
        info = UserInfo.getMyInfo();
        loadBindings();
        addObject(new MenuSelection("Controls","","","",30,Color.WHITE,Color.YELLOW),getWidth()/4,20);
        addObject(new KeyBindingSelection("Move Left",15,binds[0]),getWidth()/4,70);
        addObject(new KeyBindingSelection("Move Right",15,binds[1]),getWidth()/4,100);
        addObject(new KeyBindingSelection("Move Up",15,binds[2]),getWidth()/4,130);
        addObject(new KeyBindingSelection("Move Down",15,binds[3]),getWidth()/4,160);
        addObject(new KeyBindingSelection("Left Sholder",15,binds[4]),getWidth()/4,190);
        addObject(new KeyBindingSelection("Right Sholder",15,binds[5]),getWidth()/4,220);
        addObject(new KeyBindingSelection("Jump",15,binds[6]),getWidth()/4,250);
        addObject(new KeyBindingSelection("Attack",15,binds[7]),getWidth()/4,280);
        addObject(new KeyBindingSelection("Dash",15,binds[8]),getWidth()/4,310);
        addObject(new KeyBindingSelection("Pause/Menu",15,binds[9]),getWidth()/4,340);
        addObject(new MenuSelection("Main Menu","","","MainMenu",30,Color.WHITE,Color.YELLOW),getWidth()/2,getHeight()-30);
    }
    
    public void saveBindings(){
        String s="";
        int i=0;
        while (i<10){
            s+=binds[i]+",";
            System.out.println(s);
            i++;
        }
        info.setString(0,s);
        info.store();
    }
    String bindings="";
    public void loadBindings(){
        UserInfo info=UserInfo.getMyInfo();
        bindings=info.getString(0);
        System.out.println(bindings);
        if (bindings.indexOf(",")==-1)return;
        binds[0]=getBind();//left
        binds[1]=getBind();//right
        binds[2]=getBind();//up
        binds[3]=getBind();//down
        binds[4]=getBind();//left sholder
        binds[5]=getBind();//right sholder
        binds[6]=getBind();//jump
        binds[7]=getBind();//attack
        binds[8]=getBind();//dash
        binds[9]=getBind();//pause/menu
    }
    
    public String getBind(){
        String s="";
        if (bindings.indexOf(",")>=0){s=bindings.substring(0,bindings.indexOf(","));}
        bindings=clip(bindings);
        return s;
    }
    public String clip(String s){if (s.indexOf(",")>-1){return s.substring(s.indexOf(",")+1);}return "";}
    
    public String setBinding(String action){
        int i=0;
        while (true){
            boolean detect=false;
            for (i=0; i<keys.length; i++){
                if (i>0&&Greenfoot.isKeyDown(keys[i])){
                    detect=true;
                    break;
                }
            }
            if (detect)break;
            i=0;
        }
        if (action.equals("Move Left"))binds[0]=keys[i];
        if (action.equals("Move Right"))binds[1]=keys[i];
        if (action.equals("Move Up"))binds[2]=keys[i];
        if (action.equals("Move Down"))binds[3]=keys[i];
        if (action.equals("Left Sholder"))binds[4]=keys[i];
        if (action.equals("Right Sholder"))binds[5]=keys[i];
        if (action.equals("Jump"))binds[6]=keys[i];
        if (action.equals("Attack"))binds[7]=keys[i];
        if (action.equals("Dash"))binds[8]=keys[i];
        if (action.equals("Pause/Menu"))binds[9]=keys[i];
        saveBindings();
        return keys[i];
    }
}