import greenfoot.*;
import java.util.List;
import java.awt.Color;

public class SpikeSheetMarker extends Terrain
{   public SpikeSheetMarker(int rotate){
        turn(rotate);
        //Make Image
        GreenfootImage image = new GreenfootImage(25,25);
        image.setColor(Color.BLACK);
        image.fill();
        image.setColor(Color.GREEN);
        image.fillRect(2,2,21,21);
        image.drawImage(new GreenfootImage("ImpossibleSpike.png"),0,0);
        setImage(image);
        getImage().setTransparency(100);
    }
    public void addedToWorld(World world){
        //Make Base
        List markerCheck = getWorld().getObjects(SpikeSheetMarker.class);
        if (markerCheck.size()>1){
            Actor marker = (Actor) markerCheck.get(0);
            int width=getX()-marker.getX();
            if (width<0)width=-width;
            width+=25;
            int height=getY()-marker.getY();
            if (height<0)height=-height;
            height+=25;
            int x=getX();
            if (x>marker.getX()){x-=width/2-13;}else{x+=width/2-12;}
            int y=getY();
            if (y>marker.getY()){y-=height/2-13;}else{y+=height/2-12;}
            getWorld().addObject(new SpikeSheet(width,height,getRotation()),x,y);
            getWorld().removeObject(this);
        }
    }
    public void act(){
        if (getOneObjectAtOffset(0,0,SpikeSheet.class)!=null)getWorld().removeObject(this);
    }
}
