import greenfoot.*;
import java.util.List;
import java.awt.Color;
import javax.swing.JOptionPane;
import java.io.*;

public class XEngine extends World
{
    boolean custom = false;
    String stage=null;
    public XEngine()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1, false);
        addObject(new FadeOverlay(),getWidth()/2,getHeight()/2);
        if (!isRunningAsApplet())custom=(JOptionPane.showConfirmDialog(null,"Would you like to play a custom Level?","Notice",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION);
        if (custom){
            deleteCurrentLevel();
            loadCustomStage();
            ((FadeOverlay)getObjects(FadeOverlay.class).get(0)).fadeIn();
        }else{
            loadStage();
        }
        addObject(new X("XEngine"),xc,yc);
        addObject(new DebugInfo(),getWidth()/2,40);
        addObject(new MenuSelection("Title Screen","","","MainMenu",30,Color.WHITE,Color.YELLOW),getWidth()/2,getHeight()-20);
        addObject(new Fps(),35,50);
    }
    
    public void loadStage(){
        boolean found=false;
        if (stage==null||stage.equals("")){
            stage = JOptionPane.showInputDialog(null,"Enter the name of the stage you wish to test.\n\nAlpha Stage\nConvert Test Room\nCheckpoint Test Room\nTest Stage\nBoss Test Room\nSpike Fall\nHit Detection Test Room\nBlock Placement Test");
            if (stage.equalsIgnoreCase("Spike Fall"))JOptionPane.showMessageDialog(null,"WARNING: THIS STAGE WILL NOT BE AN ACTUAL LEVEL!\nTHIS STAGE IS MOSTLY FOR FUN, AND IS A BIT\nRIDICULOUS.");
        }
        if (stage.equalsIgnoreCase("Convert Test Room")){convertTestRoom(); found=true;}
        if (stage.equalsIgnoreCase("Test Stage")){testStage(); found=true;}
        if (stage.equalsIgnoreCase("Block Placement Test")){objectTest(); found=true;}
        if (stage.equalsIgnoreCase("Checkpoint Test Room")){checkpointTestRoom(); found=true;}
        if (stage.equalsIgnoreCase("Alpha Stage")){alphaStage(); found=true;}
        if (stage.equalsIgnoreCase("Boss Test Room")){bossTestRoom(); found=true;}
        if (stage.equalsIgnoreCase("Hit Detection Test Room")){hitDetectionTestRoom(); found=true;}
        if (stage.equalsIgnoreCase("Spike Fall")){spikeFall(); found=true;}
        ((FadeOverlay)getObjects(FadeOverlay.class).get(0)).fadeIn();
        if (found)return;
        testStage();
        JOptionPane.showMessageDialog(null,"Unable to find stage.");
    }
    
    public void loadCustomStage()
    {
        if (!custom){testStage(); return;}
        String action = "Load";
        if (true){
            String files="||ALL FILES||";;
            File folder=null;
            File game = null;
            game = new File(System.getProperty("user.dir"));
            folder = new File(game.getParent()+"/Megaman EX Levels");//Set the directory to where ever you want the Megaman EX Levels folder to be
            if (folder!=null&&!folder.exists()){
                if (JOptionPane.showConfirmDialog(null,"In order to save/load levels, a folder needs to be created.\nWould you like to create one?","WARNING",JOptionPane.YES_NO_OPTION)==JOptionPane.YES_OPTION){
                    folder.mkdir();
                    JOptionPane.showMessageDialog(null,"A new folder has been created to store custom made leves\nat this location: "+folder.getAbsolutePath());
                }
            }else if(folder!=null){
                System.out.println("Folder accessed: "+folder.getAbsolutePath());
            }else{JOptionPane.showMessageDialog(null,"Unable to create directory to save levels. Please change the\npath of where you want to save levels. It is in\nXEngine.class on line 49"); return;}
            files+=listAllFiles(folder);
            if (stage==null)stage = JOptionPane.showInputDialog(null,"Enter the name of the level you wish to load.\n\n"+files);
            System.out.println(stage);
            if (stage==null||stage.equals("")){return;}
            
            if(folder!=null){
                try{
                    File locatedLevel = new File(folder.getAbsolutePath()+"/"+stage+".dat");
                    if (!locatedLevel.exists()){
                        System.out.println(locatedLevel.getAbsolutePath());
                        JOptionPane.showMessageDialog(null,"Requested stage does not exist.");
                        testStage();
                        return;
                    }
                    repaint();
                    FileReader readlevel= new FileReader(locatedLevel);
                    BufferedReader level = new BufferedReader(readlevel);
                    String data=level.readLine();
                    int l=Integer.parseInt(data);
                    data=level.readLine();
                    int r=Integer.parseInt(data);
                    data=level.readLine();
                    int u=Integer.parseInt(data);
                    data=level.readLine();
                    int d=Integer.parseInt(data);
                    setScrollingLimits(l,r,u,d);
                    while (true){
                        data=level.readLine();
                        if (data!=null){loadClassData(data);}else{break;}
                    }
                    level.close();
                }catch(Exception e){JOptionPane.showMessageDialog(null,"An error has occured while loading the stage.\nCheck the console output for details."); e.printStackTrace(); testStage(); return;}
            }
        }
    }
    
    //Scrolling Engine and Custom Stage Loading Methods
    private boolean isRunningAsApplet(){
        return null != System.getSecurityManager();
    }
    
    public static String listAllFiles(File folder){
        if (!folder.exists()){
            JOptionPane.showMessageDialog(null,"ERROR, this folder does not exist: "+folder.getAbsolutePath());
            return "";
        }
        String levels="";
        File[] listOfFiles = folder.listFiles();
        for (File f : listOfFiles) {
            if (f.isFile()) {
               levels+="\n"+f.getName().substring(0,f.getName().indexOf("."));
            }
        }
        return levels;
    }
    int respawnWait=0;
    public void act(){
        scrollingEngine();
        setPaintOrder(VisualAffects.class,HitBoxVisual.class,GroundDetectionVisual.class,Fps.class,MouseButtons.class,DebugInfo.class,Score.class,FadeOverlay.class,healthPoint.class,HealthMeter.class,XExplosion.class,X.class,BossDoor.class,Enemies.class,xbullets.class,shot3.class,shot2.class,shot1.class,Terrain.class);
        if (Greenfoot.isKeyDown("l"))loadCustomStage();
        if (respawnWait==1){
            if (rx==0){rx=xc;}else{rx=checkpoints[ccp];}
            if (ry==0){ry=yc;}else{ry=checkpoints[ccp+1];}
            addObject(new X("XEngine"),rx,ry);
            try{((FadeOverlay)getObjects(FadeOverlay.class).get(0)).fadeIn();}catch(IndexOutOfBoundsException e){}
        }
        if (respawnWait>0){respawnWait--;}
    }
    
    boolean autoScroll=true;
    public void autoScroll(boolean a){autoScroll=a;}
    int xc=getWidth()/2;//X center of screen
    int yc=getHeight()/2;//Y center of screen
    int xX=xc;//X's X coordinate
    int xY=yc;//X's Y coordinate
    public void getCoordinates(int x, int y){xX=x; xY=y;}
    int xcorrect=0;//How much world needs to be scrolled on the X-axis
    int ycorrect=0;//How much world need to be scrolled on the Y-axis
    int s=25;//How far from center X can stray before the screen scrolls
    int llimit=500;
    int rlimit=500+llimit;
    int ulimit=200;
    int dlimit=200+ulimit;
    int xst=llimit;//How far the screen's x coordinate is away from start
    int yst=ulimit;//How far the screen's y coordinate is away from start
    public void setScrollingLimits(int left, int right, int up, int down){scrollToBeginning(); xst=left; yst=up; rlimit=right+left; llimit=left; ulimit=up; dlimit=down+up;}
    public void scrollingEngine(){scrollingEngine(0,0);}
    /**If you want to scroll the screen in a specific area, then call scrollingEngine(xcorrect,ycorrect), and this will cause the screen to scroll
       accordingingly and ignore all scrollstoppers while doing so.*/
    public void scrollingEngine(int x,int y){
        xcorrect=-x;
        ycorrect=-y;
        if (autoScroll==true){
            //Figure out how far away X is from the scrolling margin, if at all
            if (xX<xc-s){xcorrect=xc-s-xX;}else if (xX>xc+s){xcorrect=xc+s-xX;}
            if (xY<yc-s){ycorrect=yc-s-xY;}else if (xY>yc+s){ycorrect=yc+s-xY;}
        }
        //Test if the scrolling boundries have been reached, and stop scrolling if they have
        List scrollstoppers = getObjects(ScrollStopper.class);
        if (xst+-xcorrect>rlimit)xcorrect=xst-rlimit;
        if (xst+-xcorrect<0)xcorrect=xst;
        if (yst+-ycorrect>dlimit)ycorrect=yst-dlimit;
        if (yst+-ycorrect<0)ycorrect=yst;
        if (!scrollstoppers.isEmpty()&&x==0&&y==0&&autoScroll==true){
            for (int s=0; s<scrollstoppers.size(); s++){
                Actor st = (Actor) scrollstoppers.get(s);
                if (st.getX()+25+xcorrect>=0&&st.getX()-25+xcorrect<=getWidth()&&st.getY()+25+ycorrect>=0&&st.getY()-25+ycorrect<=getHeight()){
                    if (st.getX()+25>0&&st.getX()-25<getWidth()){
                        if (st.getY()>getHeight()/2){ycorrect=-(st.getY()-25-getHeight());}
                        if (st.getY()<getHeight()/2){ycorrect=-(st.getY()+25);}
                    }
                    if (respawnWait>0){
                        if (st.getY()+ycorrect+25>0&&st.getY()+ycorrect-25<getHeight()){
                            if (st.getX()>getWidth()/2){xcorrect=-(st.getX()-25-getWidth());}
                            if (st.getX()<getWidth()/2){xcorrect=-(st.getX()+25);}
                        }
                        if (respawnWait>0&&st.getX()+xcorrect+25>0&&st.getX()+xcorrect-25<getWidth()){
                            if (st.getY()>getHeight()/2){ycorrect=-(st.getY()-25-getHeight());}
                            if (st.getY()<getHeight()/2){ycorrect=-(st.getY()+25);}
                        }
                        if (st.getY()+ycorrect+25>0&&st.getY()+ycorrect-25<getHeight()){
                            if (st.getX()>getWidth()/2){xcorrect=-(st.getX()-25-getWidth());}
                            if (st.getX()<getWidth()/2){xcorrect=-(st.getX()+25);}
                        }
                    }else{
                        if (st.getY()+25>0&&st.getY()-25<getHeight()){
                            if (st.getX()>getWidth()/2){xcorrect=-(st.getX()-25-getWidth());}
                            if (st.getX()<getWidth()/2){xcorrect=-(st.getX()+25);}
                        }
                    }
                }
            }
        }
        //Track the screen's scrolling
        xst-=xcorrect; //x-axis tracking
        yst-=ycorrect; //y-axis tracking
        //Scroll world, if at all
        ((DebugInfo)getObjects(DebugInfo.class).get(0)).giveGridCoordinates(xcorrect,ycorrect);
        if (xcorrect==0&&ycorrect==0)return;
        scroll();
    }
    Class[] world = {SpriteSheet.class,Terrain.class};
    public void scroll(){
        //Scroll World
        for (int i=0; i<world.length; i++){
            List objects = getObjects(world[i]);
            if (! objects.isEmpty()){
                for (int o=0; o<objects.size(); o++){
                    Actor object = (Actor) objects.get(o);
                    object.setLocation(object.getX()+xcorrect,object.getY()+ycorrect);
                }
            }
        }
        //Update checkpoint coordinates
        if (checkpoints[0]==null)return;
        for (int i=0; i<=ccp; i+=2){
            if (checkpoints[i]==null){System.out.println("REACHED NULL BEFORE PASSING CCP"); return;}
            checkpoints[i]+=xcorrect;
            checkpoints[i+1]+=ycorrect;
        }
    }
    public void scrollToBeginning(){
        autoScroll=false;
        xcorrect=xst-llimit;
        ycorrect=yst-ulimit;
        xst=llimit;
        yst=ulimit;
        scroll();
        autoScroll=true;
    }
    
    //Level Loading Methods
    
    public void deleteCurrentLevel(){
        List terrain = getObjects(Terrain.class);
        for (int t=0; t<terrain.size(); t++){
            Actor object = (Actor) terrain.get(t);
            removeObject(object);
        }
        List SpriteSheet = getObjects(SpriteSheet.class);
        for (int i=0; i<SpriteSheet.size(); i++){
            Actor object = (Actor) SpriteSheet.get(i);
            removeObject(object);
        }
        List HUD = getObjects(HUD.class);
        for (int i=0; i<HUD.size(); i++){
            Actor object = (Actor) HUD.get(i);
            removeObject(object);
        }
        repaint();
    }
    
    private void loadClassData(String objects){
        if (objects.indexOf(".")==-1)return;
        for (int t=0; t<20; t++){
            String data=objects.substring(0,objects.indexOf("."));
            //JOptionPane.showMessageDialog(null,"objects="+objects+"\ndata="+data);
            int periods=0;
            for (int i=0; i<objects.length(); i++){
                if (objects.substring(i,i+1).equals("."))periods++;
            }
            if (periods>1){objects=objects.substring(objects.indexOf(".")+1);}
            if (data.length()==0)return;
            String o="";
            o=data.substring(0,1);
            data=data.substring(1);
            int x=0, y=0, a=0, b=0, c=0;
            //Get data of objects and add it to the world
            if (o.equals("b")){
                x=getInt(data)*25;
                data=clip(data);
                y=getInt(data)*25;
                addObject(new Box(),x,y);
            }
            if (o.equals("a")){
                x=getInt(data)*25;
                data=clip(data);
                y=getInt(data)*25;
                data=clip(data);
                a=getInt(data)*50;
                data=clip(data);
                b=getInt(data)*50;
                addObject(new Base(a,b),x,y);
            }
            if (o.equals("r")){
                x=getInt(data);
                data=clip(data);
                y=getInt(data);
                data=clip(data);
                addObject(new Brick(),x,y);
            }
            if (o.equals("w")){
                x=getInt(data);
                data=clip(data);
                y=getInt(data);
                data=clip(data);
                a=getInt(data)*25;
                data=clip(data);
                b=getInt(data)*25;
                addObject(new Wall(a,b),x,y);
            }
            if (o.equals("s")){
                //LEAVE COORDINATES OF SPIKES AS IS!!!
                x=getInt(data);
                data=clip(data);
                y=getInt(data);
                data=clip(data);
                a=getInt(data);
                addObject(new Spike(a*90),x,y);
            }
            if (o.equals("p")){
                //LEAVE COORDINATES AS IS!!!
                x=getInt(data);
                data=clip(data);
                y=getInt(data);
                data=clip(data);
                a=getInt(data)*25;
                data=clip(data);
                b=getInt(data)*25;
                data=clip(data);
                c=getInt(data);
                addObject(new SpikeSheet(a,b,c*90),x,y);
            }
            if (o.equals("c")){
                x=getInt(data)*25;
                data=clip(data);
                y=getInt(data)*25;
                addObject(new ScrollStopper(),x,y);
            }
            if (o.equals("d")){
                x=getInt(data);
                data=clip(data);
                y=getInt(data);
                data=clip(data);
                String name=data.substring(0,data.indexOf(","));
                data=clip(data);
                a=getInt(data);
                data=clip(data);
                b=getInt(data);
                data=clip(data);
                c=getInt(data)*90;
                addObject(new BossDoor(name,a,(b==1),c),x,y);
            }
            if (o.equals("y")){
                x=getInt(data)*25;
                data=clip(data);
                y=getInt(data)*25;
                data=clip(data);
                a=getInt(data);
                addObject(new SymbolBlock(a),x,y);
            }
            if (o.equals("e")){
                x=getInt(data)*25;
                data=clip(data);
                y=getInt(data)*25;
                data=clip(data);
                addObject(new EnemySpawn(data),x,y);
            }
            if (o.equals("t")){
                x=getInt(data);
                data=clip(data);
                y=getInt(data);
                data=clip(data);
                a=getInt(data)*25;
                data=clip(data);
                b=getInt(data)*25;
                addObject(new Checkpoint(a,b),x,y);
            }
            //JOptionPane.showMessageDialog(null,x+"\n"+y+"\n"+a+"\n"+b);
            repaint();
            if (periods<2)break;
        }
    }
    public int getInt(String data){
        int integer=0;
        if (data.indexOf(",")!=-1){
            integer=Integer.parseInt(data.substring(0,data.indexOf(",")));
        }else{
            integer=Integer.parseInt(data);
        }
        return integer;
    }
    public String clip(String data){
        return data.substring(data.indexOf(",")+1);
    }
    
    public void insertEnemy(int x, int y, String e){
        if (e.equals("aw"))addObject(new TestOrb(),x,y);
        if (e.equals("me"))addObject(new Metall(),x,y+6);
        if (e.equals("af"))addObject(new AwesomeFace(),x,y+9);
    }
    
    //Checkpoint Coding
    Integer[] checkpoints = new Integer[100];
    static int ccp=0;
    public void giveCheckpointCoordinates(int x, int y){
        int i=0;
        for (i=i; i<checkpoints.length; i+=2){
            if (checkpoints[i]==null)break;
            if (x==checkpoints[i]&&y==checkpoints[i+1])return;
        }
        ccp=i;
        checkpoints[ccp]=x;
        checkpoints[ccp+1]=y;
    }
    
    public void eraseCheckpoints(){
        for (int i=0; i<checkpoints.length; i++){
            if (checkpoints[i]!=null){
                checkpoints[i]=null;
            }else{
                return;
            }
        }
    }
    int rx=0;
    int ry=0;
    public void respawn()throws NullPointerException{
        try{
            rx=0;
            ry=0;
            deleteCurrentLevel();
            if (custom){loadCustomStage();}else{loadStage();}
            if (checkpoints[0]!=null){
                scrollingEngine(checkpoints[ccp],checkpoints[ccp+1]);
                rx=checkpoints[ccp];
                ry=checkpoints[ccp+1];
                scrollingEngine(rx-xc+1,ry-yc+1);
            }else{
                scrollToBeginning();
            }
            /**
            Record x and y coordinates for checkpoints of where it is on screen everytime x touches the checkpoint, and track it's positions by
            adding xcorrect and ycorrect from the scrolling engine to them. Then, when the player dies, delete/reload the level, then scroll to
            the checkpoint, and get it's exact location (have to use any leftover value from the x and y coordinates in case the screen can't
            scroll all the way so that the checkpoint is in the center of the screen), then teleport Megaman X into the screen based on checkpoint
            coordinates.**/
            respawnWait=5;
        }catch(Exception e){e.printStackTrace();}
    }
    
    
    
    
    //Data for all of the stages in the game (have to store them somewhere)
    
    
    
    
    public void testStage(){
        setScrollingLimits(1000,1000,500,200);
        addObject(new EnemySpawn("af"),getWidth()-75,getHeight()/2-25);
        addObject(new Base(500,50),getWidth()/2,getHeight()-75);
        addObject(new Box(),75,getHeight()-125);
        addObject(new Box(),125,getHeight()-125);
        addObject(new Box(),125,getHeight()-175);
        addObject(new Spike(0),162,getHeight()-113);
        addObject(new Spike(0),187,getHeight()-113);
        addObject(new Box(),225,getHeight()-125);
        addObject(new Box(),225,getHeight()-175);
        addObject(new Box(),275,getHeight()-125);
        addObject(new Box(),getWidth()-75,getHeight()-125);
        addObject(new Box(),getWidth()-75,getHeight()-175);
        addObject(new Base(50,getHeight()-50),getWidth()-25,getHeight()/2-25);
        addObject(new ScrollStopper(),425,425);
        addObject(new TestingBlock(),400,175);
        //addObject(new TestOrb(),getWidth()-100,getHeight()/2);
    }
    
    public void objectTest(){
        setScrollingLimits(0,45000,500,500);
		addObject(new Base(550,50),275,325);
		addObject(new Box(),14050,8425);
		addObject(new Box(),14050,7800);
		addObject(new Box(),14050,7175);
		addObject(new Box(),14675,7175);
		addObject(new Box(),15300,7175);
		addObject(new Box(),15300,6550);
		addObject(new Box(),15925,6550);
		addObject(new Box(),15925,5925);
		addObject(new Box(),15925,5300);
		addObject(new Box(),16550,5300);
		addObject(new Box(),16550,4675);
		addObject(new Box(),17175,4675);
		addObject(new Box(),17175,4050);
		addObject(new Box(),12800,4675);
		addObject(new Box(),12800,4050);
		addObject(new Box(),12800,3425);
		addObject(new Box(),12800,2800);
		addObject(new Box(),12800,2175);
		addObject(new Box(),13425,2175);
		addObject(new Box(),13425,1550);
		addObject(new Box(),14050,1550);
		addObject(new Box(),14675,1550);
		addObject(new Box(),15300,1550);
		addObject(new Box(),15925,1550);
		addObject(new Box(),16550,1550);
		addObject(new Box(),17175,1550);
		addObject(new Box(),17800,1550);
		addObject(new Box(),18425,1550);
		addObject(new Box(),20300,1550);
		addObject(new Box(),20300,2175);
		addObject(new Box(),20925,2175);
		addObject(new Box(),19675,1550);
		addObject(new Box(),19050,1550);
		addObject(new Box(),20925,1550);
		addObject(new Box(),20925,2800);
		addObject(new Box(),20925,3425);
		addObject(new Box(),20925,4050);
		addObject(new Box(),20925,4675);
		addObject(new Box(),20300,4675);
		addObject(new Box(),20300,5300);
		addObject(new Box(),14675,8425);
		addObject(new Box(),15300,8425);
		addObject(new Box(),15925,8425);
		addObject(new Box(),16550,8425);
		addObject(new Box(),17175,8425);
		addObject(new Box(),17800,8425);
		addObject(new Box(),18425,8425);
		addObject(new Box(),19050,8425);
		addObject(new Box(),19675,8425);
		addObject(new Box(),20300,8425);
		addObject(new Box(),20925,8425);
		addObject(new Box(),20300,9050);
		addObject(new Box(),20300,9675);
		addObject(new Box(),19675,9675);
		addObject(new Box(),875,325);
		addObject(new Box(),900,275);
		addObject(new Box(),925,225);
		addObject(new Box(),1075,125);
		addObject(new Box(),20925,925);
		addObject(new Box(),20925,300);
		addObject(new Box(),21550,-325);
		addObject(new Box(),22175,-325);
		addObject(new Box(),22175,-950);
		addObject(new Box(),22800,-950);
		addObject(new Box(),23425,-950);
		addObject(new Box(),24050,-950);
		addObject(new Box(),24675,-950);
		addObject(new Box(),25300,-950);
		addObject(new Box(),25925,-950);
		addObject(new Box(),26550,-950);
		addObject(new Box(),27175,-950);
		addObject(new Box(),27175,-325);
		addObject(new Spike(180),912,-13);
		addObject(new Spike(180),887,12);
		addObject(new Brick(),737,387);
		addObject(new Brick(),787,237);
		addObject(new Brick(),837,312);
		addObject(new Box(),1150,250);
		addObject(new Base(350,50),1250,425);
		addObject(new SpikeSheet(25,50,90),1087,175);
		addObject(new Base(50,350),1200,125);
		addObject(new Wall(325,25),1088,-64);
		addObject(new Wall(25,100),1087,-1);
		addObject(new Wall(75,25),912,-39);
		addObject(new Wall(75,25),862,-14);
		addObject(new Wall(25,225),837,112);
		addObject(new Wall(50,25),800,211);
		addObject(new Wall(275,25),687,36);
		addObject(new Wall(75,25),663,186);
		addObject(new Wall(50,25),625,211);
		addObject(new Wall(50,25),600,236);
		addObject(new Wall(25,50),587,274);
		addObject(new Wall(25,50),562,299);
		addObject(new Wall(300,25),700,336);
		addObject(new Wall(25,50),762,374);
		addObject(new Base(150,50),1000,174);
		addObject(new Base(50,250),1050,324);
    }
    
    
    public void convertTestRoom(){
        setScrollingLimits(1000,1000,500,200);
        addObject(new Box(),75,325);
        addObject(new Box(),125,325);
        addObject(new Box(),175,325);
        addObject(new Box(),225,325);
        addObject(new Box(),275,325);
        addObject(new Box(),325,325);
        addObject(new Box(),375,325);
        addObject(new Box(),425,325);
        addObject(new Box(),475,325);
        addObject(new Box(),525,325);
        addObject(new Box(),25,375);
        addObject(new Box(),75,375);
        addObject(new Box(),125,375);
        addObject(new Box(),175,375);
        addObject(new Box(),225,375);
        addObject(new Box(),275,375);
        addObject(new Box(),325,375);
        addObject(new Box(),375,375);
        addObject(new Box(),425,375);
        addObject(new Box(),475,375);
        addObject(new Box(),525,375);
        addObject(new Box(),575,375);
        addObject(new Box(),575,325);
        addObject(new Box(),575,275);
        addObject(new Box(),575,225);
        addObject(new Box(),575,175);
        addObject(new Box(),575,125);
        addObject(new Box(),575,75);
        addObject(new Box(),575,25);
        addObject(new Box(),525,25);
        addObject(new Box(),475,25);
        addObject(new Box(),425,25);
        addObject(new Box(),375,25);
        addObject(new Box(),325,25);
        addObject(new Box(),275,25);
        addObject(new Box(),225,25);
        addObject(new Box(),175,25);
        addObject(new Box(),125,25);
        addObject(new Box(),75,25);
        addObject(new Box(),25,25);
        addObject(new Box(),25,75);
        addObject(new Box(),25,125);
        addObject(new Box(),25,175);
        addObject(new Box(),25,225);
        addObject(new Box(),25,275);
        addObject(new Box(),25,325);
        addObject(new Box(),525,275);
        addObject(new Box(),525,225);
        addObject(new Box(),525,175);
        addObject(new Box(),525,125);
        addObject(new Box(),525,75);
        addObject(new Box(),475,75);
        addObject(new Box(),475,125);
        addObject(new Box(),475,175);
        addObject(new Box(),475,225);
        addObject(new Box(),475,275);
        addObject(new Box(),425,275);
        addObject(new Box(),425,225);
        addObject(new Box(),425,175);
        addObject(new Box(),425,125);
        addObject(new Box(),425,75);
        addObject(new Box(),75,75);
        addObject(new Box(),75,125);
        addObject(new Box(),75,175);
        addObject(new Box(),75,225);
        addObject(new Box(),75,275);
        addObject(new Box(),125,275);
        addObject(new Box(),125,225);
        addObject(new Box(),125,175);
        addObject(new Box(),125,125);
        addObject(new Box(),125,75);
        addObject(new Box(),175,75);
        addObject(new Box(),175,125);
        addObject(new Box(),175,175);
        addObject(new Box(),175,225);
        addObject(new Box(),175,275);
        addObject(new ScrollStopper(),275,425);
        addObject(new ScrollStopper(),325,425);
        addObject(new ScrollStopper(),625,225);
        addObject(new ScrollStopper(),625,175);
        addObject(new ScrollStopper(),275,-25);
        addObject(new ScrollStopper(),325,-25);
        addObject(new ScrollStopper(),-25,175);
        addObject(new ScrollStopper(),-25,225);
        addObject(new Box(),375,425);
        addObject(new Box(),425,425);
        addObject(new Box(),475,425);
        addObject(new Box(),525,425);
        addObject(new Box(),575,425);
        addObject(new Box(),625,425);
        addObject(new Box(),625,375);
        addObject(new Box(),625,325);
        addObject(new Box(),625,275);
        addObject(new Box(),625,125);
        addObject(new Box(),625,75);
        addObject(new Box(),625,25);
        addObject(new Box(),625,-25);
        addObject(new Box(),575,-25);
        addObject(new Box(),525,-25);
        addObject(new Box(),475,-25);
        addObject(new Box(),425,-25);
        addObject(new Box(),375,-25);
        addObject(new Box(),225,-25);
        addObject(new Box(),175,-25);
        addObject(new Box(),125,-25);
        addObject(new Box(),75,-25);
        addObject(new Box(),25,-25);
        addObject(new Box(),-25,-25);
        addObject(new Box(),-25,25);
        addObject(new Box(),-25,75);
        addObject(new Box(),-25,125);
        addObject(new Box(),-25,275);
        addObject(new Box(),-25,325);
        addObject(new Box(),-25,375);
        addObject(new Box(),-25,425);
        addObject(new Box(),25,425);
        addObject(new Box(),75,425);
        addObject(new Box(),125,425);
        addObject(new Box(),175,425);
        addObject(new Box(),225,425);
    }
    
    public void checkpointTestRoom(){
        setScrollingLimits(1000,1000,500,200);
        addObject(new Base(600,50),300,375);
        addObject(new Base(50,300),575,200);
        addObject(new Base(600,50),300,25);
        addObject(new Base(50,300),25,200);
        addObject(new ScrollStopper(),625,225);
        addObject(new ScrollStopper(),325,-25);
        addObject(new Checkpoint(25,50),137,325);
        addObject(new Checkpoint(25,50),537,325);
        addObject(new Checkpoint(25,50),387,325);
        addObject(new Spike(0),62,337);
        addObject(new Spike(0),237,337);
        addObject(new Spike(0),462,337);
        addObject(new ScrollStopper(),275,-25);
        addObject(new ScrollStopper(),-25,225);
        addObject(new ScrollStopper(),325,425);
        addObject(new ScrollStopper(),275,425);
        addObject(new ScrollStopper(),625,175);
        addObject(new ScrollStopper(),-25,175);
    }
    
    public void alphaStage(){
        setScrollingLimits(0,3000,300,900);
		addObject(new Base(500,900),900,850);
		addObject(new Base(100,100),1000,350);
		addObject(new Box(),925,375);
		addObject(new Base(550,950),1475,825);
		addObject(new Base(50,600),2975,150);
		addObject(new ScrollStopper(),3275,75);
		addObject(new Base(1100,600),2400,0);
		addObject(new Base(50,150),2425,375);
		addObject(new Base(500,100),2700,350);
		addObject(new Box(),1875,325);
		addObject(new Base(100,50),1950,475);
		addObject(new SpikeSheet(50,25,0),2025,487);
		addObject(new Box(),2075,375);
		addObject(new Base(200,50),2300,325);
		addObject(new Base(200,50),2200,475);
		addObject(new Box(),1975,425);
		addObject(new ScrollStopper(),3475,625);
		addObject(new Base(1200,100),2850,550);
		addObject(new Base(400,800),2050,900);
		addObject(new ScrollStopper(),625,875);
		addObject(new ScrollStopper(),1175,875);
		addObject(new ScrollStopper(),1775,875);
		addObject(new Checkpoint(50,100),2699,450);
		addObject(new Checkpoint(50,250),999,175);
		addObject(new ScrollStopper(),2275,625);
		addObject(new ScrollStopper(),2325,625);
		addObject(new ScrollStopper(),2375,625);
		addObject(new ScrollStopper(),2425,625);
		addObject(new ScrollStopper(),2475,625);
		addObject(new ScrollStopper(),2525,625);
		addObject(new ScrollStopper(),2575,625);
		addObject(new ScrollStopper(),2625,625);
		addObject(new ScrollStopper(),2675,625);
		addObject(new ScrollStopper(),2725,625);
		addObject(new ScrollStopper(),2775,625);
		addObject(new ScrollStopper(),2825,625);
		addObject(new ScrollStopper(),2875,625);
		addObject(new ScrollStopper(),2925,625);
		addObject(new ScrollStopper(),2975,625);
		addObject(new ScrollStopper(),3025,625);
		addObject(new ScrollStopper(),3075,625);
		addObject(new ScrollStopper(),3125,625);
		addObject(new ScrollStopper(),3175,625);
		addObject(new EnemySpawn("af"),1025,275);
		addObject(new EnemySpawn("af"),1475,325);
		addObject(new EnemySpawn("af"),2075,325);
		addObject(new EnemySpawn("af"),1975,375);
		addObject(new EnemySpawn("af"),725,375);
    }
    
    public void bossTestRoom(){
        setScrollingLimits(0,0,0,0);
        addObject(new Base(600,50),300,375);
        addObject(new Base(50,300),575,200);
        addObject(new Base(600,50),300,25);
        addObject(new Base(50,300),25,200);
        addObject(new Box(),125,325);
        addObject(new Box(),175,275);
        addObject(new Box(),175,325);
        addObject(new Box(),225,325);
        addObject(new Box(),375,325);
        addObject(new Box(),425,325);
        addObject(new Box(),425,275);
        addObject(new Box(),475,325);
        addObject(new EnemySpawn("aw"),425,225);
    }
    
    public void spikeFall(){
        setScrollingLimits(0,0,0,15100);
		addObject(new Base(50,350),25,175);
		addObject(new Base(50,400),575,200);
		addObject(new Base(100,150),100,275);
		addObject(new Base(50,350),575,575);
		addObject(new Base(100,150),450,625);
		addObject(new SpikeSheet(50,25,0),525,687);
		addObject(new SpikeSheet(50,25,0),375,687);
		addObject(new Base(100,100),300,650);
		addObject(new SpikeSheet(50,25,0),225,687);
		addObject(new Base(450,50),325,725);
		addObject(new Base(50,700),25,750);
		addObject(new Base(50,850),575,1175);
		addObject(new Base(200,50),450,1275);
		addObject(new Base(50,600),575,1900);
		addObject(new SpikeSheet(50,25,0),125,1437);
		addObject(new SpikeSheet(50,25,0),75,1287);
		addObject(new SpikeSheet(50,25,0),175,1587);
		addObject(new Base(150,450),475,1975);
		addObject(new SpikeSheet(25,250,270),337,1625);
		addObject(new Base(250,500),475,2450);
		addObject(new SpikeSheet(25,425,270),387,1962);
		addObject(new SpikeSheet(50,25,0),375,2187);
		addObject(new Base(300,450),450,2925);
		addObject(new SpikeSheet(50,25,0),325,2687);
		addObject(new SpikeSheet(25,475,270),337,2437);
		addObject(new Base(150,150),75,1525);
		addObject(new Base(100,150),50,1375);
		addObject(new Base(50,200),25,1200);
		addObject(new Base(250,750),475,3525);
		addObject(new SpikeSheet(25,450,270),287,2925);
		addObject(new Box(),225,4375);
		addObject(new SpikeSheet(50,25,0),225,4337);
		addObject(new SpikeSheet(25,50,90),262,4375);
		addObject(new SpikeSheet(50,25,180),225,4412);
		addObject(new SpikeSheet(25,50,270),187,4375);
		addObject(new Box(),375,4025);
		addObject(new SpikeSheet(50,25,0),375,3987);
		addObject(new SpikeSheet(25,50,90),412,4025);
		addObject(new SpikeSheet(50,25,180),375,4062);
		addObject(new SpikeSheet(25,50,270),337,4025);
		addObject(new Box(),275,4575);
		addObject(new SpikeSheet(50,25,0),275,4537);
		addObject(new SpikeSheet(25,50,90),312,4575);
		addObject(new SpikeSheet(50,25,180),275,4612);
		addObject(new SpikeSheet(25,50,270),237,4575);
		addObject(new Base(150,1100),525,4450);
		addObject(new Base(150,1100),75,4450);
		addObject(new SpikeSheet(25,1100,90),162,4450);
		addObject(new SpikeSheet(25,1100,270),437,4450);
		addObject(new Base(50,400),25,5200);
		addObject(new Base(50,400),575,5200);
		addObject(new EnemySpawn("af"),75,5325);
		addObject(new Base(50,150),425,975);
		addObject(new Base(250,500),125,3650);
		addObject(new SpikeSheet(25,500,90),262,3650);
		addObject(new SpikeSheet(25,750,270),337,3525);
		addObject(new Base(100,50),150,675);
		addObject(new Box(),275,975);
		addObject(new SpikeSheet(250,25,0),275,1037);
		addObject(new Base(100,50),100,1025);
		addObject(new Base(400,50),250,1075);
		addObject(new Base(200,200),100,1700);
		addObject(new SpikeSheet(50,25,0),225,1787);
		addObject(new SpikeSheet(25,175,90),212,1687);
		addObject(new Base(250,250),125,1925);
		addObject(new Base(200,1350),100,2725);
		addObject(new SpikeSheet(25,250,90),262,1925);
		addObject(new SpikeSheet(50,25,0),225,3387);
		addObject(new SpikeSheet(25,1325,90),212,2712);
		addObject(new Box(),375,4825);
		addObject(new SpikeSheet(50,25,0),375,4787);
		addObject(new SpikeSheet(50,25,180),375,4862);
		addObject(new SpikeSheet(25,50,90),412,4825);
		addObject(new SpikeSheet(25,50,270),337,4825);
		addObject(new Box(),325,4925);
		addObject(new SpikeSheet(50,25,0),325,4887);
		addObject(new SpikeSheet(25,50,90),362,4925);
		addObject(new SpikeSheet(50,25,180),325,4962);
		addObject(new SpikeSheet(25,50,270),287,4925);
		addObject(new Base(200,450),450,1525);
		addObject(new Base(450,50),275,5375);
		addObject(new Box(),475,5325);
		addObject(new Base(50,300),575,5550);
		addObject(new Base(450,50),325,5675);
		addObject(new Base(50,550),25,5675);
		addObject(new EnemySpawn("af"),175,5425);
		addObject(new Base(500,850),350,6125);
		addObject(new Base(50,850),25,6375);
		addObject(new Base(50,450),575,6775);
		addObject(new Base(50,350),25,6975);
		addObject(new Base(450,50),275,7125);
		addObject(new Base(500,100),250,7200);
		addObject(new Base(50,450),575,7225);
		addObject(new Base(200,50),450,7425);
		addObject(new Base(250,50),475,7475);
		addObject(new Base(50,700),25,7600);
		addObject(new Base(50,450),575,7725);
		addObject(new Base(100,50),300,7825);
		addObject(new SpikeSheet(25,50,270),237,7825);
		addObject(new SpikeSheet(25,50,90),362,7825);
		addObject(new Box(),425,8025);
		addObject(new Box(),175,8025);
		addObject(new Base(50,250),25,8075);
		addObject(new Base(50,250),575,8075);
		addObject(new Base(200,50),450,8125);
		addObject(new Base(200,50),150,8125);
		addObject(new SpikeSheet(200,25,0),150,8087);
		addObject(new SpikeSheet(200,25,0),450,8087);
		addObject(new Base(200,50),450,8175);
		addObject(new Base(200,50),150,8175);
		addObject(new Base(200,450),100,8425);
		addObject(new SpikeSheet(25,450,90),212,8425);
		addObject(new SpikeSheet(25,550,270),337,8375);
		addObject(new Base(150,450),75,8875);
		addObject(new Base(250,700),475,8550);
		addObject(new SpikeSheet(50,25,0),325,8887);
		addObject(new SpikeSheet(25,225,270),337,8762);
		addObject(new SpikeSheet(25,450,90),162,8875);
		addObject(new Base(300,400),450,9100);
		addObject(new Base(350,450),425,9525);
		addObject(new SpikeSheet(50,25,0),275,9287);
		addObject(new SpikeSheet(25,375,270),287,9087);
		addObject(new Base(100,950),50,9575);
		addObject(new Base(300,600),450,10050);
		addObject(new SpikeSheet(25,600,270),287,10050);
		addObject(new Base(150,500),75,10300);
		addObject(new SpikeSheet(25,925,90),112,9563);
		addObject(new Base(250,550),475,10625);
		addObject(new Base(200,500),100,10800);
		addObject(new SpikeSheet(50,25,0),175,10537);
		addObject(new SpikeSheet(25,475,90),162,10287);
		addObject(new SpikeSheet(25,550,270),337,10625);
		addObject(new Base(200,600),500,11200);
		addObject(new Base(250,650),125,11375);
		addObject(new SpikeSheet(50,25,0),225,11037);
		addObject(new SpikeSheet(25,475,90),212,10787);
		addObject(new SpikeSheet(25,600,270),387,11200);
		addObject(new Base(50,700),575,11850);
		addObject(new Base(50,500),25,11950);
		addObject(new SpikeSheet(25,450,270),237,9525);
		addObject(new SpikeSheet(25,650,90),262,11375);
		addObject(new SpikeSheet(200,25,180),150,11712);
		addObject(new SpikeSheet(150,25,180),475,11512);
		addObject(new Base(150,50),375,11925);
		addObject(new Base(100,50),100,12075);
		addObject(new Box(),525,11925);
		addObject(new SpikeSheet(50,25,0),525,11887);
		addObject(new SpikeSheet(25,50,270),487,11925);
		addObject(new SpikeSheet(50,25,180),525,11962);
		addObject(new Base(50,300),25,12350);
		addObject(new Base(400,50),200,12525);
		addObject(new SpikeSheet(350,25,0),225,12487);
		addObject(new Base(50,350),575,12375);
		addObject(new Box(),525,12225);
		addObject(new SpikeSheet(25,50,270),487,12225);
		addObject(new SpikeSheet(50,25,0),525,12187);
		addObject(new SpikeSheet(50,25,180),525,12262);
		addObject(new Box(),375,12225);
		addObject(new Base(50,250),575,12675);
		addObject(new Base(50,550),25,12825);
		addObject(new Base(200,50),450,12775);
		addObject(new Base(250,300),475,12950);
		addObject(new Box(),125,12825);
		addObject(new SpikeSheet(25,50,270),87,12825);
		addObject(new SpikeSheet(25,25,180),112,12862);
		addObject(new SpikeSheet(25,25,180),137,12862);
		addObject(new SpikeSheet(25,50,90),162,12825);
		addObject(new SpikeSheet(50,25,0),125,12787);
		addObject(new Base(150,50),275,13025);
		addObject(new Box(),75,13125);
		addObject(new Box(),225,13125);
		addObject(new SpikeSheet(50,25,0),225,13087);
		addObject(new SpikeSheet(25,50,90),262,13125);
		addObject(new SpikeSheet(50,25,180),225,13162);
		addObject(new SpikeSheet(25,50,270),187,13125);
		addObject(new Base(50,200),25,13200);
		addObject(new Base(50,200),575,13200);
		addObject(new Base(250,50),175,13275);
		addObject(new Base(150,50),475,13275);
		addObject(new Base(50,100),275,12150);
		addObject(new SpikeSheet(50,25,0),275,12087);
		addObject(new SpikeSheet(25,100,90),312,12150);
		addObject(new SpikeSheet(50,25,180),275,12212);
		addObject(new SpikeSheet(25,100,270),237,12150);
		addObject(new Base(300,300),150,13450);
		addObject(new Base(200,300),500,13450);
		addObject(new Base(50,250),575,13725);
		addObject(new Base(50,350),575,15225);
		addObject(new Base(50,1200),575,14450);
		addObject(new Base(450,50),225,375);
		addObject(new Base(600,50),300,15425);
		addObject(new Base(50,1800),25,14500);
		addObject(new ScrollStopper(),375,15475);
		addObject(new Spike(0),137,10037);
		addObject(new Spike(0),112,10037);
		addObject(new Checkpoint(50,150),449,7325);
		addObject(new Box(),275,15375);
		addObject(new Box(),325,15375);
		addObject(new SpikeSheet(150,25,0),425,15387);
		addObject(new SpikeSheet(150,25,0),175,15387);
		addObject(new Box(),75,15375);
		addObject(new EnemySpawn("af"),275,5425);
		addObject(new Base(200,50),200,5475);
		addObject(new EnemySpawn("aw"),375,15225);
		addObject(new Box(),525,15375);
		addObject(new Base(100,50),100,6675);
		addObject(new Base(100,50),100,6825);
		addObject(new SpikeSheet(50,25,0),175,6837);
		addObject(new Base(150,50),225,6875);
		addObject(new Base(50,100),325,6850);
		addObject(new Base(50,150),375,6825);
		addObject(new Base(50,250),425,6775);
		addObject(new Spike(0),437,6637);
		addObject(new SpikeSheet(25,200,270),212,6650);
		addObject(new Wall(25,200),237,6650);
		addObject(new Wall(50,25),275,6737);
		addObject(new SpikeSheet(25,75,270),387,6712);
		addObject(new Wall(50,25),375,6662);
		addObject(new Base(450,50),325,7000);
		addObject(new Wall(100,25),100,6862);
		addObject(new SpikeSheet(100,25,180),100,6887);
		addObject(new Box(),400,6625);
		addObject(new Base(200,50),425,13750);
		addObject(new Base(200,50),150,13750);
		addObject(new Base(450,50),300,13900);
		addObject(new Wall(25,50),537,13900);
		addObject(new Base(400,50),250,14050);
		addObject(new Box(),525,14050);
		addObject(new Wall(275,25),412,14162);
		addObject(new Wall(200,25),150,14162);
		addObject(new Wall(375,25),238,14237);
		addObject(new Wall(100,25),500,14237);
		addObject(new Base(400,50),300,14525);
		addObject(new Base(200,50),450,15050);
		addObject(new Base(200,50),150,15050);
		addObject(new Wall(25,50),262,15050);
		addObject(new Wall(25,50),337,15050);
		addObject(new Base(400,50),300,14875);
		addObject(new Base(200,50),150,14700);
		addObject(new Base(200,50),450,14700);
		addObject(new Wall(25,50),262,14700);
		addObject(new Wall(25,50),337,14700);
		addObject(new Checkpoint(50,125),299,14787);
    }
    
    public void hitDetectionTestRoom(){
        setScrollingLimits(0,1200,0,0);
        addObject(new TestingBlock(new GreenfootImage("HitDetectionTestImage.png")),900,200);
    }
}